"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var Incorporator_1 = require("./Incorporator");
var moduleEntries = [];
var onMounts = [];
var onUpdates = [];
var onUnmounts = [];
function setModules(mods) {
    if (mods === null || typeof mods !== 'object')
        return;
    moduleEntries = Object.entries(mods);
    onMounts = moduleEntries.map(function (mod) { return [mod[0], mod[1].componentDidMount]; }).filter(function (mod) { return mod[1]; });
    onUpdates = moduleEntries.map(function (mod) { return [mod[0], mod[1].componentDidUpdate]; }).filter(function (mod) { return mod[1]; });
    onUnmounts = moduleEntries.map(function (mod) { return [mod[0], mod[1].componentWillUnmount]; }).filter(function (mod) { return mod[1]; });
}
exports.setModules = setModules;
function usesModules() {
    return moduleEntries.length > 0;
}
exports.usesModules = usesModules;
function hasModuleProps(props) {
    return props
        ? moduleEntries.some(function (_a) {
            var mkey = _a[0];
            return props.hasOwnProperty(mkey);
        })
        : false;
}
exports.hasModuleProps = hasModuleProps;
function moduleProcessor(base, current, props) {
    if (current && base.length) {
        base.forEach(function (_a) {
            var key = _a[0], f = _a[1];
            var prop = props[key];
            if (prop)
                f(current, prop);
        });
    }
}
var Modulizer = /** @class */ (function (_super) {
    __extends(Modulizer, _super);
    function Modulizer(props) {
        var _this = _super.call(this, props) || this;
        _this.element = null;
        var targetProps = props.targetProps, targetRef = props.targetRef;
        var useRef = hasModuleProps(targetProps);
        if (targetRef) {
            if (typeof targetRef === 'function' && useRef) {
                _this.setRef = function (element) {
                    _this.element = element;
                    targetRef(element);
                };
                _this.ref = _this.setRef;
            }
            else {
                _this.ref = targetRef;
            }
        }
        else {
            _this.ref = useRef ? react_1.createRef() : null;
        }
        return _this;
    }
    Modulizer.prototype.componentDidMount = function () {
        moduleProcessor(onMounts, this.element || (this.ref && this.ref.current), this.props.targetProps);
    };
    Modulizer.prototype.componentDidUpdate = function () {
        moduleProcessor(onUpdates, this.element || (this.ref && this.ref.current), this.props.targetProps);
    };
    Modulizer.prototype.componentWillUnmount = function () {
        moduleProcessor(onUnmounts, this.element || (this.ref && this.ref.current), this.props.targetProps);
    };
    Modulizer.prototype.render = function () {
        var targetProps = __assign({}, this.props.targetProps);
        moduleEntries.forEach(function (pair) { return delete targetProps[pair[0]]; });
        var output = __assign(__assign({}, this.props), { targetRef: this.ref, targetProps: targetProps });
        return react_1.createElement(Incorporator_1.default, output);
    };
    return Modulizer;
}(react_1.Component));
exports.Modulizer = Modulizer;
//# sourceMappingURL=Modulizer.js.map