"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var incorporate_1 = require("./incorporate");
var Modulizer_1 = require("./Modulizer");
var shouldIncorporate = function (props) { return props.sel; };
function useModules(modules) {
    if (!modules || typeof modules !== 'object')
        return;
    Modulizer_1.setModules(modules);
    shouldIncorporate = function (props) { return props.sel || Modulizer_1.hasModuleProps(props); };
    incorporate_1.setIncorporator(Modulizer_1.Modulizer);
}
exports.useModules = useModules;
function createElementSpreading(type, props, children) {
    if (typeof children === 'string') {
        return react_1.createElement(type, props, children);
    }
    else {
        return react_1.createElement.apply(void 0, __spreadArrays([type, props], children));
    }
}
function hyperscriptProps(type, props) {
    if (!shouldIncorporate(props)) {
        return react_1.createElement(type, props);
    }
    else {
        return react_1.createElement(incorporate_1.incorporate(type), props);
    }
}
function hyperscriptChildren(type, children) {
    return createElementSpreading(type, null, children);
}
function hyperscriptPropsChildren(type, props, children) {
    if (!shouldIncorporate(props)) {
        return createElementSpreading(type, props, children);
    }
    else {
        return createElementSpreading(incorporate_1.incorporate(type), props, children);
    }
}
function h(type, a, b) {
    if (a === undefined && b === undefined) {
        return react_1.createElement(type, null);
    }
    if (b === undefined && (typeof a === 'string' || Array.isArray(a))) {
        return hyperscriptChildren(type, a);
    }
    if (b === undefined && typeof a === 'object' && !Array.isArray(a)) {
        return hyperscriptProps(type, a);
    }
    if (a !== undefined &&
        typeof a !== 'string' &&
        !Array.isArray(a) &&
        b !== undefined) {
        return hyperscriptPropsChildren(type, a, b);
    }
    else {
        throw new Error('Unexpected usage of h() function');
    }
}
exports.h = h;
//# sourceMappingURL=h.js.map